/*
   sequential search for "aardvark" in one file called "data"
*/

import java.io.File;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Scanner;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.time.Instant;
import java.time.Duration;

public class SearchSequential
{
   public static void main(String[] args) throws FileNotFoundException, IOException
   {
      // Open the file.
      int bufferSize = 16 * 1024 * 1024;
      BufferedInputStream bis = new BufferedInputStream(
                                new FileInputStream("data"), bufferSize);
      Scanner scanner = new Scanner(bis);

      SimpleDateFormat ft = new SimpleDateFormat("hh:mm:ss");

      System.out.println(ft.format(new Date()));
      Instant start = Instant.now();
      int lineNumber = 0;
      while ( scanner.hasNextLine() ) // this blocks
      {
         ++lineNumber;
         String oneLine = scanner.nextLine();
         // https://stackoverflow.com/questions/7384791/splitting-strings-through-regular-expressions-by-punctuation-and-whitespace-etc
         String[] tokens =  oneLine.trim().split("[\\p{Punct}\\s]+");
         for (String s : tokens)
         {
            if ( s.equals("aardvark") )
               System.out.println(ft.format(new Date()) + " " + lineNumber);
         }
      }
      Instant stop = Instant.now();
      System.out.println(ft.format(new Date()));
      long time = Duration.between(start, stop).toMillis();
      System.out.println("elapsed time: " + time + "ms");
      bis.close();
   }
}
